#include <stdio.h>
#include <stdlib.h>
#include "stm32f10x.h"
#include "sys.c"
#include "io.c"


volatile int servo1=150;  //1.5ms
volatile int servo2=150;
volatile int servo3=150;

unsigned int pwm_cnt=0;

void SysTick_Handler(void)   // SysTick Interrupt Service Routine.  interval : 0.01ms
{
  if(pwm_cnt==servo1)   PWM1(0);
  
  if(pwm_cnt==servo2)   PWM2(0);
  
  if(pwm_cnt==servo3)   PWM3(0);  

  
  pwm_cnt++;  
  if(pwm_cnt==2000) 
    { pwm_cnt=0; 
      PWM1(1); PWM2(1); PWM3(1);
    }
}



float DegRoll,DegPitch,DegYaw;

char buf[200];
char SBuf[200];
int SCnt=0;

int FindComma(char * buf)
{
   int n;
   for(n=0;n<100;n++)
    {
     if(buf[n]==',') break;
    }

   return n;
}

#define CENTER_COUNT     150
//#define COUNT_PER_ANGLE  (100./90.)
#define COUNT_PER_ANGLE  (100./100.)

#define SERVO1_OFFSET   (9)
#define SERVO2_OFFSET   0
#define SERVO3_OFFSET   (5)

void Servo1Deg(float angle)
{
  servo1 = CENTER_COUNT + (angle*COUNT_PER_ANGLE) + SERVO1_OFFSET;
}

void Servo2Deg(int angle)
{
  servo2 = CENTER_COUNT + (angle*COUNT_PER_ANGLE) + SERVO2_OFFSET;
}

void Servo3Deg(int angle)
{
  servo3 = CENTER_COUNT + (angle*COUNT_PER_ANGLE) + SERVO3_OFFSET;
}


int main(void)
{
  int angle=0;
  unsigned char buf[200];
  int value,value2;
  
  gpio_init();
  rcc_init();  
  uart_init(USART1,115200);
  uart_init(USART3,115200);

  vector_init();
  systick_init();
  
  mdelay(1000);  // wait for flash loader communication...
  put_string(USART1,"\n> start...");

  while(1)
   {

//////////////////////////////////////////////////////////////////////
     SBuf[SCnt]=getch(USART3);  // 1byte 

     if(SBuf[SCnt]==0x0a)
       {   value=FindComma(SBuf);
           SBuf[value]='\0';
           DegRoll=atof(SBuf);

           value++;
           value2=FindComma(&SBuf[value]);
           SBuf[value+value2]='\0';
           DegPitch=atof(&SBuf[value]);

           value=value+value2+1;
           value2=FindComma(&SBuf[value]);
           SBuf[value+value2]='\0';
           DegYaw=atof(&SBuf[value]);
           
//           sprintf(buf,"%f,%f,%f\n\r",DegRoll,DegPitch,DegYaw); put_string(USART1,buf);


          // Camera Control
           if((DegPitch<80)&&(DegPitch>-80)) Servo1Deg((int)DegPitch);
           if((DegRoll<80)&&(DegRoll>-80)) Servo2Deg((int)DegRoll);
           if((DegYaw<80)&&(DegYaw>-80)) Servo3Deg((int)-DegYaw);

          // Camera Stabilizer
//           if((DegPitch<80)&&(DegPitch>-80)) Servo1Deg((int)-DegPitch);
//           if((DegRoll<80)&&(DegRoll>-80)) Servo2Deg((int)-DegRoll);
//           if((DegYaw<80)&&(DegYaw>-80)) Servo3Deg((int)DegYaw);
       }
     else if(SBuf[SCnt]=='*')
       {   SCnt=-1;
       }
  
     SCnt++;
///////////////////////////////////////////////////////////////////////          
     
   }
}
     
