// STM32F103 System Library by NKJ. 


/////////// BitBanding ///////////
#define BBIO(reg,bit)   *((volatile unsigned char *)( PERIPH_BB_BASE + ((uint32_t)&reg-PERIPH_BASE)*32 + bit*4 ) )
#define BBSRAM(val,bit) *((volatile unsigned char *)( SRAM_BB_BASE + ((uint32_t)&val-SRAM_BASE)*32 + bit*4 ) )


void mdelay(volatile unsigned int d)  // about 1ms..
{
  volatile unsigned int n;
  for(;d>0;d--)
  {
     for(n=0;n<6000;n++);
  }
}


/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////// UART CONFIG ////////////////////////////////////////////

void uart_init(USART_TypeDef* USARTx, unsigned int baudrate)
{
  GPIO_InitTypeDef GPIO_InitStructure;  
  USART_InitTypeDef USART_InitStructure;  

  if(USARTx==USART1)
   {
     RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);  //  clock enable..  
     
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
     GPIO_Init(GPIOA,&GPIO_InitStructure);   // porta  tx init..  
     
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
     GPIO_Init(GPIOA,&GPIO_InitStructure);   // porta  rx init..  
   }
  else if(USARTx==USART2)
   {
     RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);  //  clock enable..  
     
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
     GPIO_Init(GPIOA,&GPIO_InitStructure);   // porta  tx init..  
     
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
     GPIO_Init(GPIOA,&GPIO_InitStructure);   // porta  rx init..  
   }
  else if(USARTx==USART3)
   {
     RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);  //  clock enable..  
     
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
     GPIO_Init(GPIOB,&GPIO_InitStructure);   // porta  tx init..  
     
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
     GPIO_Init(GPIOB,&GPIO_InitStructure);   // porta  rx init..  
   }
  else if(USARTx==UART4)
   {
     RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART4, ENABLE);  //  clock enable..  
     
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
     GPIO_Init(GPIOC,&GPIO_InitStructure);   // porta  tx init..  
     
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
     GPIO_Init(GPIOC,&GPIO_InitStructure);   // porta  rx init..  
   }
  else if(USARTx==UART5)
   {
     RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART5, ENABLE);  //  clock enable..  
     
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
     GPIO_Init(GPIOC,&GPIO_InitStructure);   // porta  tx init..  
     
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
     GPIO_Init(GPIOD,&GPIO_InitStructure);   // porta  rx init..  
   }

  //////////  USART INIT /////////
  USART_InitStructure.USART_BaudRate = baudrate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  
  USART_Init(USARTx,&USART_InitStructure);  // Init..
  USART_Cmd(USARTx,ENABLE);  // Usart enable..  
}


void putch(USART_TypeDef* USARTx, unsigned char ch)
{
  while( USART_GetFlagStatus(USARTx,USART_FLAG_TXE) == RESET );
  USART_SendData(USARTx,ch);
}
 
void put_string(USART_TypeDef* USARTx, unsigned char *str)
{ unsigned int n;
  for(n=0;str[n]!='\0';n++) putch(USARTx, str[n]);
}

unsigned char getch(USART_TypeDef* USARTx)
{
  while( USART_GetFlagStatus(USARTx, USART_FLAG_RXNE) == RESET );
  return (unsigned char)USART_ReceiveData(USARTx);
}


unsigned short getc(USART_TypeDef* USARTx)
{
  unsigned short ret;
  
  if( USART_GetFlagStatus(USARTx, USART_FLAG_RXNE) == SET )
  {  ret = (unsigned char)USART_ReceiveData(USARTx);
  }
  else 
  {  ret = 0x100;
  }
  return ret;
}


// vector_init()  ȣ //
void uart_rxint_init(USART_TypeDef* USARTx, unsigned int priority)  // priority : 0~15
{
  NVIC_InitTypeDef NVIC_InitStructure;
 
  if(USARTx==USART1)  NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;  
  else if(USARTx==USART2)  NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;  
  else if(USARTx==USART3)  NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;  
//  else if(USARTx==UART4)  NVIC_InitStructure.NVIC_IRQChannel = UART4_IRQn;  
//  else if(USARTx==UART5)  NVIC_InitStructure.NVIC_IRQChannel = UART5_IRQn;  
  else return ;
  
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = priority;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  
  USART_ITConfig(USARTx, USART_IT_RXNE, ENABLE); // Receive Interrupt
}


/*  
 
///////////// ISR /////////////  

void USART1_IRQHandler(void)
{
  if(USART_GetITStatus(USART1, USART_IT_RXNE)!=RESET)
   { 
     USART_ClearITPendingBit(USART1,USART_IT_RXNE);
//     buf=USART_ReceiveData(USART1);
   }
}

void USART2_IRQHandler(void)
{
  if(USART_GetITStatus(USART2, USART_IT_RXNE)!=RESET)
   { 
     USART_ClearITPendingBit(USART2,USART_IT_RXNE);
//     buf=USART_ReceiveData(USART2);
   }
}

void USART3_IRQHandler(void)
{
  if(USART_GetITStatus(USART3, USART_IT_RXNE)!=RESET)
   { 
     USART_ClearITPendingBit(USART3,USART_IT_RXNE);
//     buf=USART_ReceiveData(USART3);
   }
}

void UART4_IRQHandler(void)
{
  if(USART_GetITStatus(UART4, USART_IT_RXNE)!=RESET)
   { 
     USART_ClearITPendingBit(UART4,USART_IT_RXNE);
//     buf=USART_ReceiveData(UART4);
   }
}

void UART5_IRQHandler(void)
{
  if(USART_GetITStatus(UART5, USART_IT_RXNE)!=RESET)
   { 
     USART_ClearITPendingBit(UART5,USART_IT_RXNE);
//     buf=USART_ReceiveData(UART5);
   }
}
*/

//////////////////////////////////////// UART CONFIG ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////




// External clock 12MHz
// SYSCLK = 72MHz
// HCLK = 72MHz
// PCLK1 = 36MHz
// PCLK2 = 72MHz
// ADCCLK = 12MHz (14MHz MAX.)
int rcc_init(void)  
{
  int ret;
  
  RCC_DeInit();   //Resets the RCC clock configuration to the default reset state.
  
  RCC_HSEConfig(RCC_HSE_ON);  // HSE enable..
  ret = RCC_WaitForHSEStartUp();  // Wait till HSE is ready

  if(ret == SUCCESS)
  {
    FLASH_SetLatency(FLASH_Latency_2); // Flash 2 wait state  (48MHz < SYSCLK <= 72MHz) 
    
    RCC_HCLKConfig(RCC_SYSCLK_Div1); // AHB prescaler(HCLK) : HCLK = SYSCLK / 1
    RCC_PCLK1Config(RCC_HCLK_Div2); // APB low-speed prescaler(APB1) : PCLK1 = HCLK / 2
    RCC_PCLK2Config(RCC_HCLK_Div1); // APB high-speed prescaler(APB2) : PCLK2 = HCLK / 1
    RCC_ADCCLKConfig(RCC_PCLK2_Div6); // ADC prescaler(ADCCLK) : ADCCLK = PCLK2 / 6
    
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_6); // PLLMUL : x6    PLLSRC : HSE x1            //....... PLLMul Max 12
    
    RCC_PLLCmd(ENABLE); // PLL enable..
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY)==RESET);  // Wait till PLL is ready
    
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK); // Select PLL as system clock source
    while(RCC_GetSYSCLKSource()!=0x08); // Wait till PLL is used as system clock source
  }
  
  return ret;
      
}

void vector_init(void)
{
  NVIC_SetVectorTable(NVIC_VectTab_FLASH,0);  // Set the Vector Table base location at FLASH_AREA(0x08000000)
}

int systick_init(void)
{
  RCC_ClocksTypeDef RCC_ClockStructure;  
  
  RCC_GetClocksFreq(&RCC_ClockStructure);
  if(SysTick_Config(RCC_ClockStructure.SYSCLK_Frequency / 100000))   // SysTick Timer : 1msec interrupts,  SysTick_Config() MAX_value : 0xFFFFFF
    {  /* Capture error */
      return FALSE;
    }
    else
    {
      return TRUE;
    }
}
